=== docs/_build/requirements.txt ===
beautifulsoup4==4.12.3
click==8.1.8
ghp-import==2.1.0
importlib-metadata==8.5.0
Jinja2==3.1.5
Markdown>=3.2.1,<3.8
MarkupSafe==3.0.2
mergedeep==1.3.4
mkdocs==1.6.1
mkdocs-exclude==1.0.2
mkdocs-material==9.5.49
mkdocs-material-extensions==1.3.1
packaging==24.2
Pygments==2.19.1
pymdown-extensions==10.14
pyparsing==3.2.1
python-dateutil==2.9.0.post0
PyYAML==6.0.2
pyyaml_env_tag==0.1
six==1.17.0
soupsieve==2.6
watchdog==6.0.0
zipp==3.21.0
