=== plugins/cron/Makefile ===
SUBCOMMANDS = subcommands/list subcommands/report subcommands/run subcommands/set
TRIGGERS = triggers/cron-get-property
BUILD = commands subcommands triggers
PLUGIN_NAME = cron

include ../../common.mk
