=== tests/apps/python-flask/requirements.txt ===
Flask==3.1.0
Jinja2==3.1.5
Werkzeug==3.1.3
gunicorn==23.0.0
